﻿using SendGrid;
using SendGrid.Helpers.Mail;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace DocIO_Test
{
    public class EmailService
    {
        private SendGridClient m_Client { get; set; }
        public EmailService()
        {
            m_Client = new SendGrid.SendGridClient(apiKey: "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", host: "https://api.sendgrid.com/");
        }


        public async Task<Response> SendEmail(SendGridMessage message)
        {
            var result = await m_Client.SendEmailAsync(message);
            return result;
        }

        public SendGridMessage ConvertToMessage(DocumentGeneratedResponseDTO dto)
        {
            SendGridMessage message = new SendGridMessage();

            message.From = new EmailAddress { Email = "admin@iplatform.com" };
            var toEmail = new List<EmailAddress>() { new EmailAddress { Name = "Ootam Seewoogoolam", Email = "ootam@iplatform.com" } };
            message.AddTos(toEmail);
            message.Attachments = new List<Attachment>();
            message.Subject = "Welcome Email";
            message.HtmlContent = dto.FileText;
            foreach(var image in dto.AttachedImages)
            {
                message.AddAttachment($"{image.Key}.png", image.Value, "image/png", "inline", image.Key);
            }

            return message;
        }


    }
}
